<?php

namespace Drupal\content_entity_sync\Services;

use Drupal\Core\Entity\FieldableEntityInterface;
use Drupal\Core\Serialization\Yaml;

class ContentEntityImportHandler {

  public function filter($directory, $entity_type) {

    foreach (scandir($directory) as $item) {
      $path = $directory . DIRECTORY_SEPARATOR . $item;
      if (!is_file($path)) {
        continue;
      }
      $type = explode('.', $item, 2);
      $type = array_shift($type);
      if (!empty($entity_type) && $type !== $entity_type) {
        continue;
      }

      yield $path;
    }
  }

  public function read($filepath) {
    $content = Yaml::decode(file_get_contents($filepath));
    return $content;
  }

  public function upsert($content, $options) {

    $storage = \Drupal::entityTypeManager()->getStorage($content['type']);

    $entity = $storage->load($content['id']);

    if ($entity instanceof FieldableEntityInterface) {
      foreach ($content['fields'] as $name => $value) {
        if (is_array($value)) {
          foreach ($value as $key => $item) {
            if (str_starts_with($key, '_')) {
              unset($value[$key]);
            }
          }
        }

        $entity->set($name, $value);
      }
      $entity->save();
      return $entity;
    }

    // Todo implement entity_keys.
    $entity = $storage->create($content['fields'] + ['type' => $content['bundle']]);
    $entity->save();

    return $entity;
  }

}
